#include "core/utils/Error.hpp"

const char* Core::getErrorName(Error e) {
    switch(e) {
        case Error::NONE: return "NONE";
        case Error::NEGATIVE_ARGUMENT: return "NEGATIVE_ARGUMENT";
        case Error::CAPACITY_REACHED: return "CAPACITY_REACHED";
        case Error::BLOCKED_STDOUT: return "BLOCKED_STDOUT";
        case Error::OUT_OF_MEMORY: return "OUT_OF_MEMORY";
        case Error::INVALID_CHAR: return "INVALID_CHAR";
        case Error::NOT_FOUND: return "NOT_FOUND";
        case Error::INVALID_STATE: return "INVALID_STATE";
        case Error::INVALID_INDEX: return "INVALID_INDEX";
        case Error::INVALID_ARGUMENT: return "INVALID_ARGUMENT";
        case Error::TIME_NOT_AVAILABLE: return "TIME_NOT_AVAILABLE";
        case Error::SLEEP_INTERRUPTED: return "SLEEP_INTERRUPTED";
        case Error::THREAD_ERROR: return "THREAD_ERROR";
        case Error::EXISTING_KEY: return "EXISTING_KEY";
        case Error::CANNOT_OPEN_FILE: return "CANNOT_OPEN_FILE";
        case Error::END_OF_FILE: return "END_OF_FILE";
    }
    return "?";
}