#include "../src/ErrorSimulator.hpp"
#include "Test.hpp"
#include "Tests.hpp"
#include "core/utils/ArrayString.hpp"
#include "core/utils/Utility.hpp"

static void onExit(int code, void* data) {
    unsigned int i = *static_cast<unsigned int*>(data);
    Core::String32<1024> s;
    CORE_TEST_ERROR(s.append("Hello from exit #: #"));
    CORE_TEST_ERROR(s.format(code, i));
    CORE_TEST_ERROR(s.printLine());
    Core::Test::finalize();
}

int main(int argAmount, const char**) {
    bool light = argAmount <= 1;
    Core::testArrayList(light);
    Core::testArrayString();
    Core::testArray();
    Core::testBitArray();
    Core::testBox();
    Core::testBuffer(light);
    Core::testBufferedValue();
    Core::testClock(light);
    Core::testColor();
    Core::testComponents();
    Core::testError();
    Core::testFileReader();
    Core::testFrustum();
    Core::testHashMap(light);
    Core::testLinkedList(light);
    Core::testList(light);
    Core::testMath();
    Core::testMatrixStack(light);
    Core::testMatrix();
    Core::testNew();
    Core::testPlane();
    Core::testProbingHashMap(light);
    Core::testQuaternion();
    Core::testRandom(light);
    Core::testRingBuffer();
    Core::testStack(light);
    Core::testThread();
    Core::testUniquePointer();
    Core::testUtility();
    Core::testVector();
    Core::testView();

    Core::Logger::level = Core::Logger::Level::WARNING;
    CORE_LOG_DEBUG("You won't see this!");
    Core::Logger::level = Core::Logger::Level::DEBUG;

    unsigned int data = 123456789;
    Core::setExitHandler(onExit, &data);

    char buffer[] = {-100, 0};
    CORE_LOG_DEBUG(buffer);

    return 0;
}
